]> git.saurik.com Git - apt.git/blame - test/integration/framework
* apt-pkg/packagemanager.cc:
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
682a3bf7
DK
4if expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null && \
5 expr match "$(readlink -f /proc/$$/fd/2)" '/dev/pts/[0-9]\+' > /dev/null; then
6 CERROR="\e[1;31m" # red
7 CWARNING="\e[1;33m" # yellow
8 CMSG="\e[1;32m" # green
9 CINFO="\e[1;96m" # light blue
10 CDEBUG="\e[1;94m" # blue
11 CNORMAL="\e[0;39m" # default system console color
12 CDONE="\e[1;32m" # green
13 CPASS="\e[1;32m" # green
14 CFAIL="\e[1;31m" # red
15 CCMD="\e[1;35m" # pink
16fi
8d876415
DK
17
18msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
19msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
20msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
21msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
22msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
23msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
24msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
25msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
26msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
27msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
2a2a7ef4
DK
28msgtest() {
29 while [ -n "$1" ]; do
30 echo -n "${CINFO}$1${CCMD} " >&2;
31 echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " >&2;
d73840dc
DK
32 shift
33 if [ -n "$1" ]; then shift; else break; fi
2a2a7ef4
DK
34 done
35 echo -n "…${CNORMAL} " >&2;
36}
8d876415
DK
37msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
38msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
39msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
40
41# enable / disable Debugging
fc89263e
DK
42MSGLEVEL=${MSGLEVEL:-3}
43if [ $MSGLEVEL -le 0 ]; then
44 msgdie() { true; }
45fi
46if [ $MSGLEVEL -le 1 ]; then
47 msgwarn() { true; }
48 msgnwarn() { true; }
49fi
50if [ $MSGLEVEL -le 2 ]; then
51 msgmsg() { true; }
52 msgnmsg() { true; }
39cc8228
DK
53 msgtest() { true; }
54 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
55 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
682a3bf7
DK
56 if [ -n "$CFAIL" ]; then
57 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
58 else
59 msgfail() { echo -n " ###FAILED###" >&2; }
60 fi
fc89263e
DK
61fi
62if [ $MSGLEVEL -le 3 ]; then
63 msginfo() { true; }
64 msgninfo() { true; }
65fi
66if [ $MSGLEVEL -le 4 ]; then
67 msgdebug() { true; }
68 msgndebug() { true; }
69fi
70msgdone() {
71 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
72 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
73 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
74 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
75 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
76 true;
77 else
78 echo "${CDONE}DONE${CNORMAL}" >&2;
79 fi
80}
8d876415
DK
81
82runapt() {
83 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
84 if [ -f ./aptconfig.conf ]; then
85 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
86 elif [ -f ../aptconfig.conf ]; then
87 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
88 else
89 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
90 fi
8d876415
DK
91}
92aptconfig() { runapt apt-config $*; }
93aptcache() { runapt apt-cache $*; }
94aptget() { runapt apt-get $*; }
95aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 96aptkey() { runapt apt-key $*; }
ec7f904e 97aptmark() { runapt apt-mark $*; }
158fda31
DK
98dpkg() {
99 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
100}
b6b5a542
DK
101aptitude() {
102 if [ -f ./aptconfig.conf ]; then
103 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
104 elif [ -f ../aptconfig.conf ]; then
105 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
106 else
107 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
108 fi
109}
3fa950f1
DK
110gdb() {
111 echo "gdb: run »$*«"
112 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which gdb) ${BUILDDIRECTORY}/$1
113}
8d876415 114
b720d0bd
DK
115addtrap() {
116 CURRENTTRAP="$CURRENTTRAP $1"
a7e052ea 117 trap "$CURRENTTRAP exit;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
b720d0bd 118}
8d876415
DK
119
120setupenvironment() {
75954ae2 121 TMPWORKINGDIRECTORY=$(mktemp -d)
53ea1b56 122 TESTDIRECTORY=$(readlink -f $(dirname $0))
3cbbda3c 123 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
53ea1b56 124 BUILDDIRECTORY="${TESTDIRECTORY}/../../build/bin"
8d876415
DK
125 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
126 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 127 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 128 cd $TMPWORKINGDIRECTORY
cd725954 129 mkdir rootdir aptarchive keys
8d876415 130 cd rootdir
b29c3712
DK
131 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
132 mkdir -p var/cache var/lib var/log
cffea9af 133 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
cd725954 134 touch var/lib/dpkg/available
8d876415
DK
135 mkdir -p usr/lib/apt
136 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
137 cd ..
2c6baa5a 138 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
53ea1b56
DK
139 if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then
140 cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 141 fi
4a4ea26c 142 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
53ea1b56
DK
143 if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then
144 cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 145 fi
53ea1b56 146 cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/
cd725954 147 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 148 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 149 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
150 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
151 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 152 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
153 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
154 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
155 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
156 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
157 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
c204d148 158 if ! $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
53ea1b56
DK
159 echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it…
160 fi
cffea9af 161 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 162 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415 163 export LC_ALL=C
7f52cf7b 164 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
8d876415
DK
165 msgdone "info"
166}
167
ea65d079
DK
168getarchitecture() {
169 if [ "$1" = "native" -o -z "$1" ]; then
170 eval `aptconfig shell ARCH APT::Architecture`
171 if [ -n "$ARCH" ]; then
172 echo $ARCH
173 else
5834d7a1 174 dpkg --print-architecture
ea65d079
DK
175 fi
176 else
177 echo $1
178 fi
179}
180
53ea1b56
DK
181getarchitectures() {
182 echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
183}
184
8d876415
DK
185configarchitecture() {
186 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
234675b7 187 rm -f $CONFFILE
ea65d079 188 echo "APT::Architecture \"$(getarchitecture $1)\";" > $CONFFILE
8d876415
DK
189 shift
190 while [ -n "$1" ]; do
ea65d079 191 echo "APT::Architectures:: \"$(getarchitecture $1)\";" >> $CONFFILE
8d876415
DK
192 shift
193 done
53ea1b56
DK
194 configdpkg
195}
196
197configdpkg() {
198 if [ ! -e rootdir/var/lib/dpkg/status ]; then
199 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
200 if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then
201 cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status
202 else
203 echo -n > rootdir/var/lib/dpkg/status
204 fi
205 fi
c204d148 206 if $(which dpkg) --assert-multi-arch 2>&1 > /dev/null; then
53ea1b56
DK
207 local ARCHS="$(getarchitectures)"
208 if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then
209 DPKGARCH="$(dpkg --print-architecture)"
210 for ARCH in ${ARCHS}; do
211 if [ "${ARCH}" != "${DPKGARCH}" ]; then dpkg --add-architecture ${ARCH}; fi
212 done
213 if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then
05343a22
DK
214 # dpkg doesn't really check the version as long as it is fully installed,
215 # but just to be sure we choose one above the required version
216 insertinstalledpackage 'dpkg' "all" '1.16.2+fake'
53ea1b56
DK
217 fi
218 fi
219 fi
8d876415
DK
220}
221
75954ae2 222setupsimplenativepackage() {
ce9864a8
DK
223 local NAME="$1"
224 local ARCH="$2"
225 local VERSION="$3"
226 local RELEASE="${4:-unstable}"
227 local DEPENDENCIES="$5"
228 local DESCRIPTION="$6"
b7899b00
DK
229 local SECTION="${7:-others}"
230 local DISTSECTION
231 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
232 DISTSECTION="main"
233 else
234 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
235 fi
ce9864a8
DK
236 local BUILDDIR=incoming/${NAME}-${VERSION}
237 mkdir -p ${BUILDDIR}/debian/source
238 cd ${BUILDDIR}
239 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
240 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
241 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
242
243 * Initial release
244
b7899b00
DK
245 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
246 test -e debian/control || echo "Source: $NAME
247Section: $SECTION
ce9864a8
DK
248Priority: optional
249Maintainer: Joe Sixpack <joe@example.org>
250Build-Depends: debhelper (>= 7)
251Standards-Version: 3.9.1
252
875bcb36
DK
253Package: $NAME" > debian/control
254 if [ "$ARCH" = 'all' ]; then
255 echo "Architecture: all" >> debian/control
256 else
257 echo "Architecture: any" >> debian/control
258 fi
ce9864a8
DK
259 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
260 if [ -z "$DESCRIPTION" ]; then
261 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
262 If you find such a package installed on your system,
263 YOU did something horribly wrong! They are autogenerated
264 und used only by testcases for APT and surf no other propose…" >> debian/control
265 else
266 echo "Description: $DESCRIPTION" >> debian/control
267 fi
b7899b00
DK
268 test -e debian/compat || echo "7" > debian/compat
269 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 270 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
271 cd - > /dev/null
272}
273
274buildsimplenativepackage() {
275 local NAME="$1"
276 local ARCH="$2"
277 local VERSION="$3"
278 local RELEASE="${4:-unstable}"
279 local DEPENDENCIES="$5"
280 local DESCRIPTION="$6"
281 local SECTION="${7:-others}"
d67004e0 282 local PRIORITY="${8:-optional}"
75954ae2
DK
283 local DISTSECTION
284 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
285 DISTSECTION="main"
286 else
287 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
288 fi
5a635ee4 289 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 290
18331adf 291 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
292 mkdir -p $BUILDDIR/debian/source
293 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
294 echo "#!/bin/sh
295echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
296
297 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
298 echo "$NAME ($VERSION) $RELEASE; urgency=low
299
300 * Initial release
301
302 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
303 echo "Source: $NAME
304Section: $SECTION
d67004e0 305Priority: $PRIORITY
b761356f 306Maintainer: Joe Sixpack <joe@example.org>
01f520ce
DK
307Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
308 local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
309 test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
310 echo "
311Package: $NAME" >> ${BUILDDIR}/debian/control
b761356f 312
875bcb36
DK
313 if [ "$ARCH" = 'all' ]; then
314 echo "Architecture: all" >> ${BUILDDIR}/debian/control
315 else
316 echo "Architecture: any" >> ${BUILDDIR}/debian/control
317 fi
01f520ce
DK
318 local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')"
319 test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control
b761356f
DK
320 if [ -z "$DESCRIPTION" ]; then
321 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
322 If you find such a package installed on your system,
323 YOU did something horribly wrong! They are autogenerated
324 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
325 else
01f520ce 326 echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control
b761356f 327 fi
01f520ce 328
b761356f
DK
329 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
330 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 331 for SRC in $SRCS; do
5a635ee4 332 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 333 done
84aa13f4 334
ea65d079 335 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
84aa13f4
DK
336 rm -rf ${BUILDDIR}/debian/tmp
337 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
338 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
339 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
340 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
341 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
342
343 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
344 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
345 done
346
13845042
DK
347 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
348 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
349 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 350 rm -rf "${BUILDDIR}"
b761356f 351 msgdone "info"
75954ae2
DK
352}
353
354buildpackage() {
355 local BUILDDIR=$1
356 local RELEASE=$2
357 local SECTION=$3
ea65d079 358 local ARCH=$(getarchitecture $4)
75954ae2
DK
359 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
360 cd $BUILDDIR
361 if [ "$ARCH" = "all" ]; then
362 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
363 fi
b7899b00
DK
364 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
365 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 366 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 367 cd - > /dev/null
b7899b00 368 for PKG in $PKGS; do
75954ae2 369 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
370 done
371 for SRC in $SRCS; do
75954ae2 372 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 373 done
cffea9af 374 msgdone "info"
ce9864a8
DK
375}
376
377buildaptarchive() {
ce9864a8
DK
378 if [ -d incoming ]; then
379 buildaptarchivefromincoming $*
380 else
381 buildaptarchivefromfiles $*
382 fi
383}
384
385createaptftparchiveconfig() {
386 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
387 if [ -z "$ARCHS" ]; then
388 # the pool is empty, so we will operate on faked packages - let us use the configured archs
53ea1b56 389 ARCHS="$(getarchitectures)"
158fda31 390 fi
ce9864a8
DK
391 echo -n 'Dir {
392 ArchiveDir "' >> ftparchive.conf
393 echo -n $(readlink -f .) >> ftparchive.conf
394 echo -n '";
395 CacheDir "' >> ftparchive.conf
396 echo -n $(readlink -f ..) >> ftparchive.conf
397 echo -n '";
b7899b00
DK
398 FileListDir "' >> ftparchive.conf
399 echo -n $(readlink -f pool/) >> ftparchive.conf
400 echo -n '";
401};
402Default {
bc33e0f0
DK
403 Packages::Compress ". gzip bzip2 lzma xz";
404 Sources::Compress ". gzip bzip2 lzma xz";
405 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 406 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 407 LongDescription "false";
ce9864a8
DK
408};
409TreeDefault {
410 Directory "pool/";
411 SrcDirectory "pool/";
412};
413APT {
414 FTPArchive {
415 Release {
416 Origin "joesixpack";
417 Label "apttestcases";
418 Suite "unstable";
419 Description "repository with dummy packages";
420 Architectures "' >> ftparchive.conf
421 echo -n "$ARCHS" >> ftparchive.conf
422 echo 'source";
423 };
424 };
425};' >> ftparchive.conf
b7899b00
DK
426 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
427 echo -n 'tree "dists/' >> ftparchive.conf
428 echo -n "$DIST" >> ftparchive.conf
429 echo -n '" {
ce9864a8
DK
430 Architectures "' >> ftparchive.conf
431 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
432 echo -n 'source";
433 FileList "' >> ftparchive.conf
434 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
435 echo -n '";
436 SourceFileList "' >> ftparchive.conf
437 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
438 echo -n '";
439 Sections "' >> ftparchive.conf
440 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
441 echo '";
ce9864a8 442};' >> ftparchive.conf
b7899b00 443 done
ce9864a8
DK
444}
445
446buildaptftparchivedirectorystructure() {
b7899b00
DK
447 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
448 for DIST in $DISTS; do
449 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
450 for SECTION in $SECTIONS; do
451 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
452 for ARCH in $ARCHS; do
453 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
454 done
455 mkdir -p dists/${DIST}/${SECTION}/source
456 mkdir -p dists/${DIST}/${SECTION}/i18n
457 done
ce9864a8 458 done
ce9864a8
DK
459}
460
9b78cda6
DK
461insertpackage() {
462 local RELEASE="$1"
463 local NAME="$2"
464 local ARCH="$3"
465 local VERSION="$4"
466 local DEPENDENCIES="$5"
d67004e0
DK
467 local PRIORITY="${6:-optional}"
468 local ARCHS=""
ea65d079 469 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
d67004e0 470 if [ "$arch" = "all" ]; then
53ea1b56 471 ARCHS="$(getarchitectures)"
d67004e0
DK
472 else
473 ARCHS="$arch"
474 fi
475 for BUILDARCH in $ARCHS; do
476 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
477 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
478 touch aptarchive/dists/${RELEASE}/main/source/Sources
479 local FILE="${PPATH}/Packages"
480 echo "Package: $NAME
481Priority: $PRIORITY
9b78cda6 482Section: other
2c085486 483Installed-Size: 42
9b78cda6 484Maintainer: Joe Sixpack <joe@example.org>
d67004e0 485Architecture: $arch
2c085486 486Version: $VERSION
d67004e0
DK
487Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
488 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
489 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
490 If you find such a package installed on your system,
491 YOU did something horribly wrong! They are autogenerated
492 und used only by testcases for APT and surf no other propose…
493" >> $FILE
d67004e0 494 done
9b78cda6
DK
495 done
496}
497
234675b7
DK
498insertsource() {
499 local RELEASE="$1"
500 local NAME="$2"
501 local ARCH="$3"
502 local VERSION="$4"
503 local DEPENDENCIES="$5"
504 local ARCHS=""
505 local SPATH="aptarchive/dists/${RELEASE}/main/source"
506 mkdir -p $SPATH
507 local FILE="${SPATH}/Sources"
508 echo "Package: $NAME
509Binary: $NAME
510Version: $VERSION
511Maintainer: Joe Sixpack <joe@example.org>
512Architecture: $ARCH" >> $FILE
513 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
514 echo "Files:
515 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
d5dea0be
DK
516 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz
517" >> $FILE
234675b7
DK
518}
519
dfc2b1be
DK
520insertinstalledpackage() {
521 local NAME="$1"
522 local ARCH="$2"
523 local VERSION="$3"
524 local DEPENDENCIES="$4"
d67004e0 525 local PRIORITY="${5:-optional}"
d4b4e5ea 526 local STATUS="${6:-install ok installed}"
53ea1b56
DK
527 local FILE='rootdir/var/lib/dpkg/status'
528 local INFO='rootdir/var/lib/dpkg/info'
ea65d079 529 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g' | sed -e "s#^native\$#$(getarchitecture 'native')#"); do
d67004e0 530 echo "Package: $NAME
d4b4e5ea 531Status: $STATUS
d67004e0 532Priority: $PRIORITY
dfc2b1be
DK
533Section: other
534Installed-Size: 42
535Maintainer: Joe Sixpack <joe@example.org>
d67004e0 536Architecture: $arch
dfc2b1be 537Version: $VERSION" >> $FILE
d67004e0
DK
538 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
539 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
540 If you find such a package installed on your system,
541 YOU did something horribly wrong! They are autogenerated
542 und used only by testcases for APT and surf no other propose…
543" >> $FILE
53ea1b56
DK
544 if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then
545 echo -n > ${INFO}/${NAME}:${arch}.list
546 else
547 echo -n > ${INFO}/${NAME}.list
548 fi
d67004e0 549 done
dfc2b1be
DK
550}
551
552
ce9864a8 553buildaptarchivefromincoming() {
3cbbda3c 554 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
555 cd aptarchive
556 [ -e pool ] || ln -s ../incoming pool
557 [ -e ftparchive.conf ] || createaptftparchiveconfig
558 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 559 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 560 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
561 cd - > /dev/null
562 msgdone "info"
9b78cda6 563 generatereleasefiles
ce9864a8
DK
564}
565
566buildaptarchivefromfiles() {
3cbbda3c 567 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
568 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
569 msgninfo "\t${line} file… "
570 cat ${line} | gzip > ${line}.gz
571 cat ${line} | bzip2 > ${line}.bz2
8bcbc694 572 cat ${line} | xz --format=lzma > ${line}.lzma
b7080ced 573 cat ${line} | xz > ${line}.xz
8d876415 574 msgdone "info"
9b78cda6
DK
575 done
576 generatereleasefiles
577}
578
a3bbbab7
DK
579# can be overridden by testcases for their pleasure
580getcodenamefromsuite() { echo -n "$1"; }
581getreleaseversionfromsuite() { true; }
718f797c 582getlabelfromsuite() { true; }
a3bbbab7 583
9b78cda6 584generatereleasefiles() {
884a4c0a
DK
585 # $1 is the Date header and $2 is the ValidUntil header to be set
586 # both should be given in notation date/touch can understand
9b78cda6
DK
587 msgninfo "\tGenerate Release files… "
588 if [ -e aptarchive/dists ]; then
589 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
590 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
591 local CODENAME="$(getcodenamefromsuite $SUITE)"
592 local VERSION="$(getreleaseversionfromsuite $SUITE)"
718f797c 593 local LABEL="$(getlabelfromsuite $SUITE)"
884a4c0a 594 if [ -n "$VERSION" ]; then
718f797c
DK
595 VERSION="-o APT::FTPArchive::Release::Version=${VERSION}"
596 fi
597 if [ -n "$LABEL" ]; then
598 LABEL="-o APT::FTPArchive::Release::Label=${LABEL}"
a3bbbab7 599 fi
884a4c0a
DK
600 aptftparchive -qq release $dir \
601 -o APT::FTPArchive::Release::Suite="${SUITE}" \
602 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
718f797c 603 ${LABEL} \
884a4c0a
DK
604 ${VERSION} \
605 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
a3bbbab7 606 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
607 sed -i '/^Date: / a\
608NotAutomatic: yes' $dir/Release
609 fi
884a4c0a
DK
610 if [ -n "$1" -a "$1" != "now" ]; then
611 sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release
612 fi
613 if [ -n "$2" ]; then
614 sed -i "/^Date: / a\
615Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release
616 fi
9b78cda6
DK
617 done
618 else
619 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 620 fi
884a4c0a 621 if [ -n "$1" -a "$1" != "now" ]; then
fe0f7911
DK
622 for release in $(find ./aptarchive -name 'Release'); do
623 touch -d "$1" $release
624 done
8d876415 625 fi
b7899b00 626 msgdone "info"
8d876415
DK
627}
628
b7899b00
DK
629setupdistsaptarchive() {
630 local APTARCHIVE=$(readlink -f ./aptarchive)
631 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
632 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
633 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
634 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
635 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
636 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
637 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
638 msgdone "info"
639 done
640}
641
642setupflataptarchive() {
ce9864a8 643 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
644 if [ -f ${APTARCHIVE}/Packages ]; then
645 msgninfo "\tadd deb sources.list line… "
646 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
647 msgdone "info"
648 else
649 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
650 fi
651 if [ -f ${APTARCHIVE}/Sources ]; then
652 msgninfo "\tadd deb-src sources.list line… "
653 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
654 msgdone "info"
655 else
656 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
657 fi
b7899b00
DK
658}
659
660setupaptarchive() {
661 buildaptarchive
662 if [ -e aptarchive/dists ]; then
663 setupdistsaptarchive
664 else
665 setupflataptarchive
666 fi
f213b6ea 667 signreleasefiles
cd725954 668 msgninfo "\tSync APT's cache with the archive… "
8d876415 669 aptget update -qq
cd725954 670 msgdone "info"
8d876415
DK
671}
672
f213b6ea
DK
673signreleasefiles() {
674 local SIGNER="${1:-Joe Sixpack}"
675 msgninfo "\tSign archive with $SIGNER key… "
676 local SECKEYS=""
677 for KEY in $(find keys/ -name '*.sec'); do
678 SECKEYS="$SECKEYS --secret-keyring $KEY"
679 done
680 local PUBKEYS=""
681 for KEY in $(find keys/ -name '*.pub'); do
682 PUBKEYS="$PUBKEYS --keyring $KEY"
683 done
684 for RELEASE in $(find aptarchive/ -name Release); do
685 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 686 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
687 done
688 msgdone "info"
689}
690
691changetowebserver() {
692 if which weborf > /dev/null; then
693 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 694 addtrap "kill $!;"
6e7d39d0
DK
695 elif which gatling > /dev/null; then
696 cd aptarchive
697 gatling -p 8080 -F -S 2>&1 > /dev/null &
698 addtrap "kill $!;"
699 cd - > /dev/null
c5bcc607
DK
700 elif which lighttpd > /dev/null; then
701 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
702server.port = 8080
703server.stat-cache-engine = \"disable\"" > lighttpd.conf
704 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
705 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
706 addtrap "kill $!;"
707 else
708 msgdie 'You have to install weborf or lighttpd first'
709 return 1
f213b6ea 710 fi
c5bcc607
DK
711 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
712 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
713 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
714 done
715 return 0
f213b6ea
DK
716}
717
718checkdiff() {
8d876415
DK
719 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
720 if [ -n "$DIFFTEXT" ]; then
721 echo
722 echo "$DIFFTEXT"
723 return 1
724 else
725 return 0
726 fi
727}
728
75954ae2
DK
729testfileequal() {
730 local FILE="$1"
731 shift
732 msgtest "Test for correctness of file" "$FILE"
733 if [ -z "$*" ]; then
f213b6ea 734 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 735 else
f213b6ea 736 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
737 fi
738}
739
b855a400
DK
740testempty() {
741 msgtest "Test for no output of" "$*"
742 test -z "$($* 2>&1)" && msgpass || msgfail
743}
744
8d876415
DK
745testequal() {
746 local COMPAREFILE=$(mktemp)
b720d0bd 747 addtrap "rm $COMPAREFILE;"
8d876415
DK
748 echo "$1" > $COMPAREFILE
749 shift
750 msgtest "Test for equality of" "$*"
f213b6ea 751 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
752}
753
685625bd
DK
754testequalor2() {
755 local COMPAREFILE1=$(mktemp)
756 local COMPAREFILE2=$(mktemp)
757 local COMPAREAGAINST=$(mktemp)
b720d0bd 758 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
759 echo "$1" > $COMPAREFILE1
760 echo "$2" > $COMPAREFILE2
761 shift 2
762 msgtest "Test for equality OR of" "$*"
763 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
764 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
765 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
766 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
767 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
768 msgfail )
769}
770
8d876415 771testshowvirtual() {
edc0ef10 772 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
773 local PACKAGE="$1"
774 shift
775 while [ -n "$1" ]; do
776 VIRTUAL="${VIRTUAL}
edc0ef10 777N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
778 PACKAGE="${PACKAGE} $1"
779 shift
780 done
781 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
782 VIRTUAL="${VIRTUAL}
4bec02c2 783N: No packages found"
8d876415 784 local COMPAREFILE=$(mktemp)
b720d0bd 785 addtrap "rm $COMPAREFILE;"
ea65d079 786 local ARCH="$(getarchitecture 'native')"
8d876415 787 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 788 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
789}
790
791testnopackage() {
792 msgtest "Test for non-existent packages" "apt-cache show $*"
793 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
794 if [ -n "$SHOWPKG" ]; then
795 echo
796 echo "$SHOWPKG"
797 msgfail
798 return 1
799 fi
800 msgpass
801}
01a6e24c
DK
802
803testdpkginstalled() {
804 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
805 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
806 if [ "$PKGS" != $# ]; then
01a6e24c
DK
807 echo $PKGS
808 dpkg -l $* | grep '^[a-z]'
809 msgfail
810 return 1
811 fi
812 msgpass
813}
814
5cf733e1
DK
815testdpkgnotinstalled() {
816 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 817 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
818 if [ "$PKGS" != 0 ]; then
819 echo
820 dpkg -l $* | grep '^[a-z]'
821 msgfail
822 return 1
823 fi
824 msgpass
825}
ec7f904e
DK
826
827testmarkedauto() {
828 local COMPAREFILE=$(mktemp)
829 addtrap "rm $COMPAREFILE;"
830 if [ -n "$1" ]; then
831 msgtest 'Test for correctly marked as auto-installed' "$*"
832 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
833 else
834 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 835 echo -n > $COMPAREFILE
ec7f904e
DK
836 fi
837 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
838}
89a1aa5d
DK
839
840pause() {
841 echo "STOPPED execution. Press enter to continue"
842 local IGNORE
843 read IGNORE
844}